Subject: Re: [BEHAVE] secdir review of draft-ietf-behave-turn-ipv6-09

From: Simon Perreault <[email-masked]>
Date: Tue, 06 Apr 2010 20:27:49 -0400

On 03/29/2010 05:45 PM, Richard Barnes wrote:
> My only significant concern that is not addressed in the
> document is how this mechanism relates to the routing loop attacks
> introduced by other forms of v4/v6 translation and tunneling, e.g., as
> discussed in this paper:
> <http://www.usenix.org/events/woot09/tech/full_papers/nakibly.pdf>
> It's not immediately obvious to me that extending TURN in this way makes
> these (currently non-TURN-related) attacks viable, but I would encourage
> the authors to consider the issue and add some text to the document
> explaining how the attacks do or do not apply here.

(See bottom of this email.)

> S.3, Paragraph "Assuming the request..."
> The server doesn't "assume" that the request is authenticated.  Suggest
> rephrasing as "After the request has been successfully authenticated, ..."

Agreed, fixed.

> S4.1.1
> Why not just make this option one byte long?  If you're already
> anticipating a usage for the reserved space, you should just specify it.

STUN attributes must be padded to a multiple of 4 bytes. (Reference: RFC
5389, section 15.)

> S4.2, First paragraph
> As above, suggest rephrasing as "Once a server has verified that the
> request is authenticated and has not been tampered with, ..."

Agreed, fixed.

> S4.3
> Why is this a SHOULD NOT and not a MUST NOT?  What's the exceptional case?

I have no idea. I'll change it to a MUST NOT unless I receive more info
from my co-authors.

> Section 9, First para
> It seems overly broad to say that "an IPv4-only client having access to
> ... this specifictation is now able to access the IPv6 Internet".  The
> client can't just send/receive traffic with any node, right?  Explain
> the restrictions in place here.

The client can indeed send/receive traffic with any node (as long as it
is allowed by local security policy).

Could you please explain the restrictions you have in mind?

> Section 9,
> Might some of the Teredo / 6to4 loop attacks apply as well?  If not, why
> not?
> -- Spoof 4-to-6 allocate request from relay's v4 address
> -- Spoof authorization relay's v6 address
> -- Spoof packet from either of relay's addresses

Sure, these are ways of spoofing IPv6 packets that are enabled by Teredo
and 6to4. There are many others. Is there a reference we can cite? Would
citing the Usenix paper be OK?

> If there is some risk here, you might consider saying something like
> "Server MUST NOT allocate 6to4 or Teredo addresses or accept them as
> peers"?

I have no idea if that would be right or not. Can somebody with a clue
please weigh in?

Thanks,
Simon
-- 
NAT64/DNS64 open-source --> http://ecdysis.viagenie.ca
STUN/TURN server        --> http://numb.viagenie.ca
vCard 4.0               --> http://www.vcarddav.org